/*****************************************************************************
 *
 * LibUnrawel, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef BILINEAR_INTERPOLATOR_H
#define BILINEAR_INTERPOLATOR_H

#include "RawInterpolator.h"
//-----------------------------------------------------------------------------
class BilinearInterpolator: public RawInterpolator
  {
  public:
    static BilinearInterpolator& GetInterpolator();

    virtual bool Interpolate(Image& image, const RawImageInfo& image_info);

    virtual void GetParameters(Params& o_params) const;

    virtual void GetDescriptions(Params& o_params) const;

    virtual void SetParameters(Params& i_params);

  protected:
    BilinearInterpolator();

  private:
    const RawImageInfo* mp_image_info;
    bool m_fl_only_chroma;
    ulong m_nbhd_size;

  private:
    void InterpolateGreenPixel(Image& image, unsigned row, unsigned col);

    void InterpolateChromaPixel(Image& image, unsigned row, unsigned col);
  };
//-----------------------------------------------------------------------------
#endif // BILINEAR_INTERPOLATOR_H
