/*****************************************************************************
 *
 * LibUnrawel, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef CHROMA_DIFF_FLOW_IMAGE_PROCESSOR_H
#define CHROMA_DIFF_FLOW_IMAGE_PROCESSOR_H

#include "ImageProcessor.h"
#include "Image.h"
//-----------------------------------------------------------------------------
class ChromaDiffFlowImageProcessor: public ImageProcessor
  {
  public:
    static ChromaDiffFlowImageProcessor& GetImageProcessor();

    void Process(Image& image, const RawImageInfo& image_info, const std::string& method);

    void ApplyDiffusionFlow(Image& image, const RawImageInfo& image_info);

    virtual void GetParameters(Params& o_params) const;

    virtual void GetDescriptions(Params& o_params) const;

    virtual void SetParameters(Params& i_params);

  protected:
    ChromaDiffFlowImageProcessor();

  private:
    const RawImageInfo* mp_image_info;
    float m_amount_brightness, m_amount_chroma;
    ulong m_diff_num_of_iter;

  private:
    void ApplyStep(Image& img, const ImageTmpl<PixelCB>& img_ch, unsigned row, unsigned col,
		   float step_br, float step_ch);
  };
//-----------------------------------------------------------------------------
#endif // CHROMA_DIFF_FLOW_IMAGE_PROCESSOR_H
