/*****************************************************************************
 *
 * LibUnrawel, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef IMAGE_SIMPLE_FILTERS_H
#define IMAGE_SIMPLE_FILTERS_H

#include "ImageProcessor.h"
//-----------------------------------------------------------------------------
class ImageSimpleFilters: public ImageProcessor
  {
  public:
    static ImageSimpleFilters& GetImageProcessor();

    void Process(Image& image, const RawImageInfo& image_info, const std::string& method);

  private:
    ImageSimpleFilters();

    void RawFilterPixelByMedian(Image& image, unsigned row, unsigned col,
				uchar ind, std::vector<ushort>& arr);

    void FilterPixelByMedian(Image& image, unsigned row, unsigned col,
			     uchar ind, std::vector<ushort>& arr);

    void RawFilterPixelByDiagMedian(Image& image, unsigned row, unsigned col,
				    uchar ind, std::vector<ushort>& arr);

    void FilterPixelByDiagMedian(Image& image, unsigned row, unsigned col,
				 uchar ind, std::vector<ushort>& arr);

    void FilterByMedian(Image& image, const RawImageInfo& image_info,
			bool fl_use_diag);

    void ApplyUltraResolution(Image& image, const RawImageInfo& image_info);

    void SimpleNoiseFilter(Image& image, const RawImageInfo& image_info);

    virtual void GetParameters(Params& o_params) const;

    virtual void GetDescriptions(Params& o_params) const;

    virtual void SetParameters(Params& i_params);

  private:
    ulong m_median_dim, m_raw_median_dim;
    float m_median_strength, m_noise_filter_strength;
  };
//-----------------------------------------------------------------------------

#endif // IMAGE_SIMPLE_FILTERS_H
