/*****************************************************************************
 *
 * LibUnrawel, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef PARAMS_H
#define PARAMS_H

#include "MyException.h"
//-----------------------------------------------------------------------------
class Params: public std::map<std::string, std::string>
  {
  public:
    class ExBadParameter: public MyException
      { 
      public:
	ExBadParameter(const std::string& i_err_id, const std::string& msg): MyException("ParameterLayer", i_err_id, msg) {}
      };

    std::string& operator [] (const std::string& key)
      {
      iterator it = find(key);

      if (it != end())
	return it -> second;
      else
	return insert(value_type(key, "")).first -> second;
      }

    bool exist(const std::string& key) const
      {
      return find(key) != end();
      }

    std::string pop(const std::string& key)
      {
      iterator it = find(key);

      if (it == end())
	throw ExBadParameter("UnknownKey", "Unknown key " + key);

      std::string ret = it -> second;

      erase(it);

      return ret;
      }

    const std::string& operator [] (const std::string& key) const
      {
      const_iterator it = find(key);

      if (it == end())
	throw ExBadParameter("UnknownKey", "Unknown key " + key);

      return it -> second;
      }
  };
//-----------------------------------------------------------------------------
#endif // PARAMS_H
