/*****************************************************************************
 *
 * LibUnrawel, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef PARAMS_DISPATCHER_H
#define PARAMS_DISPATCHER_H

#include "Params.h"
//-----------------------------------------------------------------------------
class IParametrizable;
//-----------------------------------------------------------------------------
class ParamsDispatcher
  {
  public:
    typedef std::pair<std::string, Params> ModuleInfo;
    typedef std::list<ModuleInfo> ParamsList;

    static ParamsDispatcher& GetDispatcher();

    void Register(const std::string& module, IParametrizable* ip_client);

    void UnRegister(IParametrizable* ip_client);

    void GetParameters(ParamsList& o_params) const;

    void GetDescriptions(ParamsList& o_params) const;

    void SetParameters(Params& i_params) const;

  private:
    ParamsDispatcher();

  private:
    typedef std::pair<std::string, IParametrizable*> ClientInfo;
    typedef std::list<ClientInfo> ClientsList;

    ClientsList m_clients;
  };
//-----------------------------------------------------------------------------
#endif // PARAMS_DISPATCHER_H
