/*****************************************************************************
 *
 * LibUnrawel, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef POSITION_H
#define POSITION_H

//-----------------------------------------------------------------------------
struct Position
  {
  unsigned m_row, m_col;

  Position() {}

  Position(unsigned row, unsigned col): m_row(row), m_col(col) {}

  ulong Distance(const Position& pos) const
    {
    return sqr(pos.m_row - m_row) + sqr(pos.m_col - m_col);
    }

  bool operator == (const Position& pos) const
    {
    return pos.m_row == m_row && pos.m_col == m_col;
    }

  bool operator != (const Position& pos) const
    {
    return !(*this == pos);
    }
  };
//-----------------------------------------------------------------------------

#endif // POSITION_H

