/*****************************************************************************
 *
 * LibUnrawel, Copyright (C) 2002-2003 by Alexander Tsvyashchenko
 * contact address: <spam@ndl.kiev.ua>
 *
 * short license info is below, but it concerns only program itself -
 * you should see copyrights.txt for algorithms licenses info!
 *
 *****************************************************************************

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

******************************************************************************/

#ifndef TYPES_H
#define TYPES_H
//-----------------------------------------------------------------------------
// General assumptions about types:
// - char has >= 8 bits (should be always satisfied as it is requirement of C++ standard)
// - short has >= 16 bits
// - long has >= 32 bits
// int, unsigned int >= 16 bits (possibly in some places there are
// assumptions that int or unsigned int are >= 32 bits, but I cannot
// reliably test this as I don't have appropriate platform - on my
// platform int and unsigned int are 32 bits)
//
//-----------------------------------------------------------------------------
typedef unsigned char uchar;
typedef unsigned short ushort;
typedef unsigned long ulong;
//-----------------------------------------------------------------------------
#ifdef WIN32
typedef __int64 ulong64;
#else
typedef unsigned long long ulong64;
#endif
//-----------------------------------------------------------------------------
#endif // TYPES_H
